import DataLoader from 'dataloader';
import { Optional, TimelessDateString } from '../../../shared/types/index.js';
import { TenantAwareDBClient } from '../../app-providers/tenant-db-client.js';
import type { IGetSimilarTransactionsParams, IGetTransactionsByFiltersParams, IReplaceTransactionsChargeIdParams, IUpdateTransactionsParams } from '../types.js';
type IGetAdjustedTransactionsByFiltersParams = Optional<Omit<IGetTransactionsByFiltersParams, 'isIDs' | 'fromEventDate' | 'toEventDate' | 'fromDebitDate' | 'toDebitDate'>, 'IDs' | 'businessIDs'> & {
    fromEventDate?: TimelessDateString | null;
    toEventDate?: TimelessDateString | null;
    fromDebitDate?: TimelessDateString | null;
    toDebitDate?: TimelessDateString | null;
};
export declare class TransactionsProvider {
    private db;
    constructor(db: TenantAwareDBClient);
    private batchTransactionsByIds;
    transactionByIdLoader: DataLoader<string, import("../types.js").IGetTransactionsByIdsResult, string>;
    getTransactionsByMissingRequiredInfo(): Promise<import("../types.js").IGetTransactionsByMissingRequiredInfoResult[]>;
    private batchTransactionsByChargeIDs;
    transactionsByChargeIDLoader: DataLoader<string, import("../types.js").IGetTransactionsByChargeIdsResult[], string>;
    getTransactionsByFilters(params: IGetAdjustedTransactionsByFiltersParams): Promise<import("../types.js").IGetTransactionsByFiltersResult[]>;
    getSimilarTransactions(params: IGetSimilarTransactionsParams): Promise<import("../types.js").IGetSimilarTransactionsResult[]>;
    replaceTransactionsChargeId(params: IReplaceTransactionsChargeIdParams): Promise<import("../types.js").IReplaceTransactionsChargeIdResult[]>;
    updateTransactions(params: IUpdateTransactionsParams): Promise<import("../types.js").IUpdateTransactionsResult[]>;
    invalidateTransactionByChargeID(chargeId: string): Promise<void>;
    invalidateTransactionByID(id: string): Promise<void>;
    clearCache(): void;
}
export {};
